<template>
  <v-menu v-model="isOpen" offset-y :close-on-content-click="false" max-width="250px">
    <template v-slot:activator="{ on, attrs }">
      <v-btn
        class="mr-2"
        outlined
        v-bind="attrs"
        color="accent"
        small
        v-on="on"
      >
        <span class="text-capitalize">
          {{ label }}
        </span>
        <v-icon right>
          {{ mdiChevronDown }}
        </v-icon>
      </v-btn>
    </template>
    <v-card class="px-4">
      <v-row>
        <v-col cols="6">
          <v-select
            :value="filters[minName]"
            hide-details
            return-object
            dense
            label="Min"
            :items="minOpts"
            @change="changeFocus"
            @input="setFilter(minName, $event.value)"
          />
        </v-col>
        <v-col cols="6">
          <v-select
            ref="maxElement"
            :value="filters[maxName]"
            hide-details
            return-object
            dense
            label="Max"
            :items="maxOpts"
            @change="close"
            @input="setFilter(maxName, $event.value)"
          />
        </v-col>
      </v-row>
    </v-card>
  </v-menu>
</template>

<script lang="ts">
import { mdiChevronDown } from '@mdi/js'
import { defineComponent, ref } from '@vue/composition-api'
import { debounce } from 'ts-debounce'
import { useQuery } from '@/hooks'
import { InternalFilters } from '@/utils/query'

type Options = {
  min: Array<[number | undefined, string]>
  max: Array<[number | undefined, string]>
}

export default defineComponent({
  name: 'FilterSelect',
  props: {
    name: {
      type: String,
      required: true
    },
    options: {
      type: Object,
      required: true
    },
    label: {
      type: String,
      required: true
    }
  },
  setup (props, context) {
    const { filters, setFilter } = useQuery(context)
    const isOpen = ref(false)
    const maxElement = ref<any>(null)
    const changeFocus = () => {
      maxElement.value!.isMenuActive = true
    }
    const close = () => {
      isOpen.value = false
    }
    return {
      filters,
      changeFocus,
      maxElement,
      close,
      mdiChevronDown,
      isOpen,
      minName: 'min' + props.name as keyof InternalFilters,
      maxName: 'max' + props.name as keyof InternalFilters,
      setFilter: debounce(setFilter, 1500),
      minOpts: [{ value: undefined, text: 'No min' }, ...props.options.min],
      maxOpts: [...props.options.max, { value: undefined, text: 'No max' }]
    }
  }
})
</script>
